package pps.core.middle.service;

import cn.hutool.core.date.DateTime;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import pps.core.middle.entity.StationMappingEnt;
import pps.core.middle.mapper.StationMappingMapper;
import pps.core.middle.service.data.station_mapping.GetStationMappingInput;
import pps.core.middle.service.data.station_mapping.GetStationMappingOutput;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.XStartup;
import xstartup.data.XSingleResult;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;

import java.io.File;
import java.util.List;

@XService
public class StationMappingService {
    @XApiAnonymous
    @XApiGet(anonymous = true)
    public XSingleResult<GetStationMappingOutput> getStationMapping(XContext context, GetStationMappingInput input) {
        StationMappingMapper mapper = context.getBean(StationMappingMapper.class);
        List<StationMappingEnt> list = mapper.selectList(new LambdaQueryWrapper<>());
        for (StationMappingEnt stationMappingEnt : list) {
            context.getLogger().info(JSONUtil.toJsonStr(stationMappingEnt));
        }
        try {
            String storeDir = XStartup.getCurrent().getProperty("weather.file.temp.path");
            StringBuilder stringBuilder = new StringBuilder(storeDir)
                    .append(File.separator)
                    .append(DateTime.now().toString("yyyyMMdd"));
            String filePath = stringBuilder.append(File.separator).append("test.json").toString();
            String url = "http://192.168.0.128:9090/api/v1/buckets/sunbox/objects/download?prefix=MjAyNDEwMTgxNjAw5aSp5rCU6aKE5rWL5pWw5o2uU1kuanNvbg==&version_id=a16cddb9-e170-434d-b391-e84454e007a3";
            HttpUtil.downloadFile(url, filePath);
            context.getLogger().info(filePath);
        } catch (Exception e) {
            context.getLogger().error(e.getMessage(), e);
        }
        return XSingleResult.success();
    }
}
